<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: buglist.php,v 1.47 2004/02/09 03:30:29 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['type']))     { $type     = $_REQUEST['type']; }     else { $type     = NULL; }
if (isset($_REQUEST['search']))   { $search   = $_REQUEST['search']; }   else { $search   = NULL; }
if (isset($_REQUEST['allclass'])) { $allclass = $_REQUEST['allclass']; } else { $allclass = NULL; }
if (isset($_REQUEST['myclass']))  { $myclass  = $_REQUEST['myclass']; }  else { $myclass  = NULL; }
if (isset($_REQUEST['who']))      { $who      = $_REQUEST['who']; }      else { $who      = NULL; }
if (isset($_REQUEST['rwho']))     { $rwho     = $_REQUEST['rwho']; }     else { $rwho     = NULL; }
if (isset($_REQUEST['product']))  { $product  = $_REQUEST['product']; }  else { $product  = NULL; }
if (isset($_REQUEST['vproduct'])) { $vproduct = $_REQUEST['vproduct']; } else { $vproduct = NULL; }
if (isset($_REQUEST['sversion'])) { $sversion = $_REQUEST['sversion']; } else { $sversion = NULL; }
if (isset($_REQUEST['eversion'])) { $eversion = $_REQUEST['eversion']; } else { $eversion = NULL; }
if (isset($_REQUEST['sort']))     { $sort     = $_REQUEST['sort']; }     else { $sort     = "bid"; }
if (isset($_REQUEST['order']))    { $order    = $_REQUEST['order']; }    else { $order    = "ASC"; }
if (isset($_REQUEST['sdate']))    { $sdate    = $_REQUEST['sdate']; }    else { $sdate    = NULL; }
if (isset($_REQUEST['sxdate']))   { $sxdate   = $_REQUEST['sxdate']; }   else { $sxdate   = NULL; }
if (isset($_USER['uid']))         { $uid      = $_USER['uid']; }         else { $uid      = 0; }
$msg      = NULL;
$overprod = NULL;

if (isset($type) || isset($search))
{
    d_StartPage(gettext("Bug List"));
    if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) { exit; }
    d_DrawNav($user['uname']);

    d_DrawHeader(gettext("Bug List"));

    if ($_SERVER['REQUEST_METHOD'] == "GET")
    { 
        // reconstruct our query string without sort order
        $token = strtok($_SERVER['QUERY_STRING'], "&");
        $c     = 0;
        while ($token)
        {
            if (!ereg("^sort.*", $token))
            {
                if (!ereg("^order.*", $token))
                {
                    if ($c == 0)
                    {
                        $string = $token;
                    } else {
                        $string = $string . "&" . $token;
                    }
                }
            }
            $c++;
            $token = strtok("&");
        }
    } elseif ($_SERVER['REQUEST_METHOD'] == "POST") { // reconstruct our query string without sort order
        $c = 0;
        for ($HTTP_POST_VARS; $k=key($HTTP_POST_VARS); next($HTTP_POST_VARS))
        {
            if ($k != "sort")
            {
                if ($k != "order")
                {
                    if ($HTTP_POST_VARS[$k] != "")
                    {
                        if ($c == 0)
                        {
                            $string = $k . "=" . $HTTP_POST_VARS[$k];
                        } else {
                            $string = $string . "&" . $k . "=" . $HTTP_POST_VARS[$k];
                        }
                    }
                }
            }
            $c++;
        }
    }

    switch($type)
    {
        case "all":
            if ($allclass == "all")
            {
                if (isset($search))
                {
                    $msg     = sprintf(gettext("Searching for all bugs containing search phrase \"<b>%s</b>\""), $search);
                } else {
                    $query   = "";
                    $msg     = gettext("Searching for all bugs...");
                }
            } else {
                $query   = "WHERE status = '$allclass'";
                $tmpname = $db->getOne("SELECT name FROM status_d WHERE id = '$allclass'");
                $msg     = sprintf(gettext("Searching for all bugs of status %s..."), $tmpname);
            }
            break;
        case "unres":
            $query = "WHERE status NOT IN (4,6)";
            $msg   = gettext("Searching for all unresolved bugs...");
            break;
        case "mine":
            if ($myclass == "all")
            {
                $query = "WHERE assigned = '$uid'";
                $msg   = gettext("Searching for all of your bugs...");
            } elseif ($myclass == "new") {
                $query = "WHERE assigned= '$uid' AND status NOT IN (4,6,7)";
                $msg   = gettext("Searching for all of your unresolved bugs...");
            } else {
                $query   = "WHERE assigned = '$uid' AND status = '$myclass'";
                $tmpname = $db->getOne("SELECT name FROM status_d WHERE id = '$myclass'");
                $msg     = sprintf(gettext("Searching for all of your bugs of status %s..."), $tmpname);
            }
            break;
        case "user":
            $query    = "WHERE assigned = '$who'";
            $tmpemail = $db->getOne("SELECT email FROM users WHERE uid = '$who'");
            $msg      = sprintf(gettext("Searching for all bugs belonging to %s..."), $tmpemail);
            break;
        case "reporter":
            $query    = "WHERE reporter = '$uid'";
            $tmpemail = $db->getOne("SELECT email FROM users WHERE uid = '$uid'");
            $msg      = sprintf(gettext("Searching for all bugs reported by %s..."), $tmpemail);
            break;
        case "reporternew":
            $query    = "WHERE reporter = '$uid' AND status = '1'";
            $tmpemail = $db->getOne("SELECT email FROM users WHERE uid = '$uid'");
            $msg      = sprintf(gettext("Searching for all new bugs reported by %s..."), $tmpemail);
            break;
        case "reportby":
            $query    = "WHERE reporter = '$rwho'";
            $tmpemail = $db->getOne("SELECT email FROM users WHERE uid = '$rwho'");
            $msg      = sprintf(gettext("Searching for all bugs reported by %s..."), $tmpemail);
            break;
        case "product":
            if ($product != "")
            {
                $query    = "WHERE product = '$product'";
                $tmpname  = $db->getOne("SELECT name FROM products WHERE pid = '$product'");
                $msg      = sprintf(gettext("Searching for all bugs of product %s..."), "<b>$tmpname</b>");
                $overprod = 1;
            } else {
                $query = "";
                $msg   = gettext("Searching for all bugs of all products...");
            }
            break;
        case "versiondiff":
            d_AskVersion($vproduct);
            $exit = 1;
            break;
        case "bydate":
            $query = "WHERE creation >= '$sdate'";
            $msg   = sprintf(gettext("Searching for all bugs reported since %s"), d_getTime($sdate));
            break;
        case "resdate":
            $query = "WHERE modified >= '$sxdate' AND (status = '4' OR status = '6')";
            $msg   = sprintf(gettext("Searching for all bugs RESOLVED or CLOSED since %s"), d_getTime($sxdate));
            break;
        default:
            $msg = gettext("No action specified.");
            $exit = 1;
            break;
    }

    if (isset($exit)) { print($msg); d_DrawFooter(); exit; }

    print("<p>$msg</p>");

    if ($overprod == 1)
    {
        $pidnum = 1;
    } else {
        $result = $db->query("SELECT pid FROM products WHERE deleted = '0'");
        dberror($result);
        $pidnum = $result->numRows();
        $result->free();
    }

    $url  = $PHP_SELF . "?" . $string;
    $up   = "<img src=\"" . $_CONF['webroot'] . $_CONF['imgdir'] . "/arrow_up_blue.gif\" border=\"0\" alt=\"^\">";
    $down = "<img src=\"" . $_CONF['webroot'] . $_CONF['imgdir'] . "/arrow_down_blue.gif\" border=\"0\" alt=\"v\">";

    $p_string['bug']        = gettext("Bug");
    $p_url['bug_asc']       = sprintf("<a href=\"%s&sort=bid&order=ASC\">%s</a>", $url, $up);
    $p_url['bug_desc']      = sprintf("<a href=\"%s&sort=bid&order=DESC\">%s</a>", $url, $down);
    $p_string['product']    = gettext("Product");
    $p_url['prod_asc']      = sprintf("<a href=\"%s&sort=prod&order=ASC\">$up</a>", $url);
    $p_url['prod_desc']     = sprintf("<a href=\"%s&sort=prod&order=DESC\">$down</a>", $url);
    $p_string['component']  = gettext("Component");
    $p_url['comp_asc']      = sprintf("<a href=\"%s&sort=comp&order=ASC\">$up</a>", $url);
    $p_url['comp_desc']     = sprintf("<a href=\"%s&sort=comp&order=DESC\">$down</a>", $url);
    $p_string['priority']   = gettext("Priority");
    $p_url['pri_asc']       = sprintf("<a href=\"%s&sort=pri&order=ASC\">$up</a>", $url);
    $p_url['pri_desc']      = sprintf("<a href=\"%s&sort=pri&order=DESC\">$down</a>", $url);
    $p_string['owner']      = gettext("Owner");
    $p_url['own_asc']       = sprintf("<a href=\"%s&sort=own&order=ASC\">$up</a>", $url);
    $p_url['own_desc']      = sprintf("<a href=\"%s&sort=own&order=DESC\">$down</a>", $url);
    $p_string['status']     = gettext("Status");
    $p_url['stat_asc']      = sprintf("<a href=\"%s&sort=stat&order=ASC\">$up</a>", $url);
    $p_url['stat_desc']     = sprintf("<a href=\"%s&sort=stat&order=DESC\">$down</a>", $url);
    $p_string['resolution'] = gettext("Resolution");
    $p_url['res_asc']       = sprintf("<a href=\"%s&sort=res&order=ASC\">$up</a>", $url);
    $p_url['res_desc']      = sprintf("<a href=\"%s&sort=res&order=DESC\">$down</a>", $url);
    $p_string['summary']    = gettext("Summary");
    $p_url['summ_asc']      = sprintf("<a href=\"%s&sort=summ&order=ASC\">$up</a>", $url);
    $p_url['summ_desc']     = sprintf("<a href=\"%s&sort=summ&order=DESC\">$down</a>", $url);

    $data = <<<EOT
        <table cellpadding="0" cellspacing="0" border="0" width="100%">
            <tr bgcolor="{$config['barcol1']}">
                <td valign="top" nowrap><b>{$p_string['bug']}#</b>&nbsp; {$p_url['bug_asc']} {$p_url['bug_desc']}</td>
EOT;
    if ($pidnum > 1)
    {
        $data .= <<<EOT
                <td valign="top" nowrap><b>{$p_string['product']}</b>&nbsp; {$p_url['prod_asc']} {$p_url['prod_desc']}</td>
EOT;
    }
    $data .= <<<EOT
                <td valign="top" nowrap><b>{$p_string['component']}</b>&nbsp; {$p_url['comp_asc']} {$p_url['comp_desc']}</td>
                <td valign="top" nowrap><b>{$p_string['priority']}</b>&nbsp; {$p_url['pri_asc']} {$p_url['pri_desc']}</td>
                <td valign="top" nowrap><b>{$p_string['owner']}</b>&nbsp; {$p_url['own_asc']} {$p_url['own_desc']}</td>
                <td valign="top" nowrap><b>{$p_string['status']}</b>&nbsp; {$p_url['stat_asc']} {$p_url['stat_desc']}</td>
                <td valign="top" nowrap><b>{$p_string['resolution']}</b>&nbsp; {$p_url['res_asc']} {$p_url['res_desc']}</td>
                <td valign="top" nowrap><b>{$p_string['summary']}</b>&nbsp; {$p_url['summ_asc']} {$p_url['summ_desc']}</td>
            </tr>
EOT;

    print($data);

    if (isset($search))
    {
        $count = d_doSearchList($search, $sort, $order, $pidnum);
    } else {
        $count = d_doBugList($query, $sort, $order, $pidnum);
    }

    $p_found   = sprintf(gettext("%s bugs found"), $count);
    $p_retlink = gettext("Return to <a href=\"query.php\">Bug list</a>.");

    $data    = <<<EOT
        </table>
        <br />
        <span class="text"><center>{$p_found}.</span></center>
        <p>{$p_retlink}</p>
EOT;

    print($data);

    d_DrawFooter();
    exit;
}

// generate version diffs
if (isset($sversion) || isset($eversion))
{
    d_StartPage(gettext("Bug List"));
    if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) { exit; }
    d_DrawNav($user['uname']);

    d_DrawHeader(gettext("Bug List"));
    $pname               = $db->getOne("SELECT name FROM products WHERE (pid = '$product') AND (deleted = '0')");
    $p_listfix           = sprintf(gettext("Listing FIXED bugs for product \"%s\" between versions %s and %s"),$pname,$sversion,$eversion);
    $p_string['bug']     = gettext("Bug");
    $p_string['fixver']  = gettext("Fixed Version");
    $p_string['summary'] = gettext("Summary");
    $data                = <<<EOT
        <p>{$p_listfix}</p>
        <table cellpadding="0" cellspacing="1" border="0" width="100%">
            <tr>
                <td valign="top" nowrap><b>{$p_string['bug']}#</b></td>
                <td valign="top" nowrap><b>{$p_string['fixver']}</b></td>
                <td valign="top" nowrap><b>{$p_string['summary']}</b></td>
            </tr>
EOT;

    print($data);

    $result = $db->query("SELECT * FROM bugs WHERE (fixedver >= '$sversion') AND (fixedver <= '$eversion') AND (product = '$product') ORDER BY fixedver");
    dberror($result);
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        d_DumpVdiff($row);
    }
    $result->free();
    print("</table>");
    d_DrawFooter();
    exit;
}

header("Location: " . $_CONF['webroot'] . "/query.php");
?>
