<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: createattachment.php,v 1.21 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['bug']))             { $bug         = $_REQUEST['bug']; }             else { $bug         = NULL; }
if (isset($_REQUEST['doit']))            { $doit        = $_REQUEST['doit']; }            else { $doit        = NULL; }
if (isset($_REQUEST['type']))            { $type        = $_REQUEST['type']; }            else { $type        = NULL; }
if (isset($_REQUEST['description']))     { $description = $_REQUEST['description']; }     else { $description = NULL; }
if (isset($_FILES['afile']['size']))     { $afile_size  = $_FILES['afile']['size']; }     else { $afile_size  = NULL; }
if (isset($_FILES['afile']['name']))     { $afile_name  = $_FILES['afile']['name']; }     else { $afile_name  = NULL; }
if (isset($_FILES['afile']['tmp_name'])) { $afile       = $_FILES['afile']['tmp_name']; } else { $afile       = NULL; }
if (isset($_FILES['afile']['type']))     { $afile_type  = $_FILES['afile']['type']; }     else { $afile_type  = NULL; }
if (isset($_FILES['afile']['error']))    { $afile_error = $_FILES['afile']['error']; }    else { $afile_error = NULL; }

d_StartPage(gettext("Upload Attachment"));
d_DrawNav($_USER['uname']);
d_DrawHeader(gettext("Upload Attachment"));

$private = $db->getOne("SELECT private FROM bugs WHERE bid = $bug");
if ($private == 1 && !isset($_USER['uid']))
{
    print(gettext("The bug you selected is marked private and is not available to unregistered users."));
    d_DrawFooter();
    exit;
}

if (isset($doit))
{
    // attachment to upload
    if ($description == "")
    {
        print("<p>" . gettext("You need to enter a description of the attachment.") . "</p>");
        d_DrawFooter();
        exit;
    }
    if ($type == "")
    {
        print("<p>" . gettext("You need to enter a MIME type.") . "</p>");
        d_DrawFooter();
        exit;
    }
    if ($afile_error == "4")
    {
        // UPLOAD_ERR_NO_FILE
        print("<p>" . gettext("No attachment uploaded.") . "</p>");
        d_DrawFooter();
        exit;
    }
    if ($afile_size == 0)
    {
        print("<p>" . gettext("The attachment uploaded is zero bytes.") . "</p>");
        d_DrawFooter();
        exit;
    }
    if ($afile_error == "2")
    {
        // UPLOAD_ERR_FORM_SIZE
        print("<p>" . gettext("The attachment uploaded is too large.") . "</p>");
        d_DrawFooter();
        exit;
    }
    if ($afile_error == 1)
    {
        // UPLOAD_ERR_INI_SIZE
        print("<p>" . gettext("The attachment is larger than the system-wide maximum upload file size.") . "</p>");
        d_DrawFooter();
        exit;
    }
    if ($afile_error == 3)
    {
        //UPLOAD_ERR_PARTIAL
        print("<p>" . gettext("The attachment was not completely uploaded.") . "</p>");
        d_DrawFooter();
        exit;
    }
    if (!is_uploaded_file($afile))
    {
        print("<p>" . gettext("The attachment was not uploaded... possible file upload attack?") . "</p>");
        d_DrawFooter();
        exit;
    }
    // final safety check
    if ($afile_error != 0)
    {
        print("<p>" . gettext("There was an unknown error with your attachment upload.") . "</p>");
        d_DrawFooter();
        exit;
    }

    switch($type)
    {
        case "text/plain":
            $accepted = 1; break;
        case "image/gif":
            $accepted = 1; break;
        case "image/png":
            $accepted = 1; break;
        case "image/jpeg":
            $accepted = 1; break;
        case "application/octet-stream":
            $accepted = 1; break;
        default:
            $accepted = 0;
    }

    if ($accepted == 0)
    {
        print("<p>" . sprintf(gettext("You provided an illegal MIME type!  Type: %s is not permitted."), $type) . "</p>");
        d_DrawFooter();
        exit;
    }

    // get the next name for the attachment
    $nextattach = $db->nextID('attachidx');

    $fname  = $afile_name;
    $newdir = $_CONF['root'] . $_CONF['attachdir'] . "/" . $nextattach;
    // make sure the directory doesn't exist
    if (is_dir($newdir))
    {
        // if it does, try to increment by one.. if that fails, send error
        $nextattach = $db->nextID('attachidx');;
        $newdir = $_CONF['root'] . $_CONF['attachdir'] . "/" . $nextattach;
        if (is_dir($newdir))
        {
            print("<p>" . gettext("ERROR: Attachment directory already exists.  Upload aborted.") . "</p>");
            print("<p>" . gettext("Please notify the administrator of this site of this error.") . "</p>");
            d_DrawFooter();
            exit;
        }
    }

    $newdir  = $_CONF['root'] . $_CONF['attachdir'] . "/" . $nextattach;
    @mkdir($newdir, octdec("0755"));
    $newfile = $newdir . "/" . $fname;

    if (!move_uploaded_file($afile, $newfile))
    {
        print("<p>" . gettext("Problem copying attachment.  Aborting.") . "</p>");
        d_DrawFooter();
        exit;
    }

    $update = date("YmdHis");

    print("<p>" . gettext("Attachment uploaded successfully!") . "</p>");

    $url   = sprintf("showattachment.php/%s/%s", $nextattach, $fname);
    $cmnt  = sprintf(gettext("<a href=\"%s\">Created an attachment (id=%s)</a>\n"), $url, $nextattach);
    $cmnt2 = gettext("Description of attachment") . " #$nextattach: " . $description;

    $id     = $db->nextID('bugdesc');
    $query  = "INSERT INTO bugdesc (did, bid, b_user, b_date, system, description) VALUES ";
    $query .= "('$id','$bug','" . $_USER['uid'] . "','$update',1,";
    $query .= "'" . addslashes($cmnt) . "')";
    $result = $db->query($query);
    dberror($result);
    $id     = $db->nextID('bugdesc');
    $query  = "INSERT INTO bugdesc (did, bid, b_user, b_date, system, description) VALUES ";
    $query .= "('$id','$bug','" . $_USER['uid'] . "','$update',0,";
    $query .= "'" . addslashes($cmnt2) . "')";
    $result = $db->query($query);
    dberror($result);

    $id     = $db->nextID('bugactivity'); 
    $query  = "INSERT INTO bugactivity (aid, bid, b_user, b_date, what) ";
    $query .= "VALUES ('$id', '$bug', '" . $_USER['uid'] . "', ";
    $query .= "'$update', '5')";
    $result = $db->query($query);
    dberror($result);

    $query  = "INSERT INTO attachidx (atid, bid, a_date, mimetype, filename, a_user)";
    $query .= " VALUES ('$nextattach', '$bug', '$update', '$type', '$fname', ";
    $query .= "'" . $_USER['uid'] . "')";
    $result = $db->query($query);
    dberror($result);

    d_doDiff($bug);

    print("<p><a href=\"query.php?bug=$bug\">" . sprintf(gettext("Return to bug #%s"), $bug) . "</a>.</p>");

    d_DrawFooter();

} else {
    if (!isset($bug))
    {
        print("<p>" . gettext("Error: you must select a bug to associate attachment with!") . "</p>");
        d_DrawFooter();
        exit;
    }

    $result = $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
    dberror($result);
    $row    = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $result->free();

    // if status RESOLVED or CLOSED and not owner or admin, disallow
    // creating attachments
    if ($row['status'] == "4" || $row['status'] == "6")
    {
        if ($_USER['uid'] != $row['assigned'] || $_USER['access'] < $config['adminac'])
        {
            print("<p>" . gettext("This bug is CLOSED or RESOLVED and you may not create an attachment.") . "</p>");
            d_DrawFooter();
            exit;
        }
    }

    if (!isset($_USER['uid']))
    {
        // not logged in
        print("<p>" . gettext("You must be logged in first.") . "</p>");
        d_DrawFooter();
        exit;
    }

    d_DrawCAttach($bug);

    d_DrawFooter(); 
} 
?>
