<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: editcomponents.php,v 1.29 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['action']))      { $action      = $_REQUEST['action']; }      else { $action      = NULL; }
if (isset($_REQUEST['pid']))         { $pid         = $_REQUEST['pid']; }         else { $pid         = NULL; }
if (isset($_REQUEST['cid']))         { $cid         = $_REQUEST['cid']; }         else { $cid         = NULL; }
if (isset($_REQUEST['name']))        { $name        = $_REQUEST['name']; }        else { $name        = NULL; }
if (isset($_REQUEST['owner']))       { $owner       = $_REQUEST['owner']; }       else { $owner       = NULL; }
if (isset($_REQUEST['description'])) { $description = $_REQUEST['description']; } else { $description = NULL; }

d_StartPage(gettext("Select Component"));

if (!do_checkacs($_USER['access'])) exit;

d_DrawNav($_USER['uname']);

// form to add new component
if ($action == "add")
{
    d_DrawHeader(gettext("Add Component"));
    d_DrawEditComp("insert",0,$pid);
    print("<p>" . sprintf(gettext("Return to <a href=\"editcomponents.php?pid=%s\">components</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// insert new component
if ($action == "insert")
{
    d_DrawHeader(gettext("Add Component"));
    // make sure a component by this name doesn't already exist
    $result = $db->query("SELECT cid FROM components WHERE (name = '$name') AND (deleted = '0') AND (product = '$pid')");
    dberror($result);
    if ($result->numRows() > 0)
    {
        $msg = "2";
    } else {
        if ($name == "")
        {
            $msg = "3";
        } else {
            // clean up the autocc string
            $tmp    = explode(",",$autocc);
            $x      = count($tmp);
            for ($i=0; $i<$x; $i++)
            {
                $tmp[$i] = trim($tmp[$i]);
            }
            $autocc  = implode($tmp,", ");
            $id      = $db->nextID('components');
            $query   = "INSERT INTO components (cid, name, product, ";
            $query  .= "owner, description, autocc) VALUES ";
            $query  .= "('$id', ";
            $query  .= "'" . addslashes(htmlspecialchars($name)) . "', '" . $pid . "', ";
            $query  .= "'" . addslashes(htmlspecialchars($owner)) . "', ";
            $query  .= "'" . addslashes(htmlspecialchars($description)) . "',";
            $query  .= "'" . addslashes(htmlspecialchars($autocc)) . "')";
            $result2 = $db->query($query);
            dberror($result2);
            $msg = "1";
        }
    }
    $result->free();
    header(sprintf("Location: $PHP_SELF?pid=%s&msg=%s", $pid, $msg));
    exit;
}

// form to delete component
if ($action == "del")
{
    d_DrawHeader(gettext("Delete Component"));
    $cname              = $db->getOne("SELECT name FROM components WHERE cid = '$cid'");
    $p_delcomp          = sprintf(gettext("Are you sure you want to delete the component <b>%s</b>?"), stripslashes($cname));
    $p_string['delete'] = gettext("Delete");
    $data               = <<<EOT
        <form method="post" action="editcomponents.php">
        <p>{$p_delcomp}</p>
        <input type="submit" value="{$p_string['delete']}">
        <input type="hidden" name="cid" value="{$cid}">
        <input type="hidden" name="pid" value="{$pid}">
        <input type="hidden" name="action" value="delete">
        </form>
EOT;

    print($data);
    d_DrawFooter();
    exit;
}

// perform delete
if ($action == "delete")
{
    d_DrawHeader(gettext("Delete Component"));
    $result = $db->query("UPDATE components SET deleted = '1' WHERE cid = '$cid'");
    dberror($result);
    header(sprintf("Location: $PHP_SELF?pid=%s&msg=4", $pid));
    exit;
}

// form to edit component
if ($action == "edit")
{
    d_DrawHeader(gettext("Change Component"));
    d_DrawEditComp("change",$cid,$pid);
    print("<p>" . sprintf(gettext("Return to <a href=\"editcomponents.php?pid=%s\">components</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// change component
if ($action == "change")
{
    d_DrawHeader(gettext("Change Component"));
    // clean up the autocc string
    $tmp    = explode(",",$autocc);
    $x      = count($tmp);
    for ($i=0; $i<$x; $i++)
    {
        $tmp[$i] = trim($tmp[$i]);
    }
    $autocc = implode($tmp,", ");
    $query  = "UPDATE components SET name = '" . addslashes(htmlspecialchars($name)) . "' ";
    $query .= "WHERE cid = '$cid'";
    $result = $db->query($query);
    dberror($result);
    $query  = "UPDATE components SET owner = '" . addslashes(htmlspecialchars($owner)) . "' ";
    $query .= "WHERE cid = '$cid'";
    $result = $db->query($query);
    dberror($result);
    $query  = "UPDATE components SET description = '" . addslashes(htmlspecialchars($description)) . "' ";
    $query .= "WHERE cid = '$cid'";
    $result = $db->query($query);
    dberror($result);
    $query  = "UPDATE components SET autocc = '" . addslashes(htmlspecialchars($autocc)) . "' ";
    $query .= "WHERE cid = '$cid'";
    $result = $db->query($query);
    dberror($result);
    print("<span class=\"text\"><center>" . gettext("Component changed.") . "</center></span>");
    print("<p>" . sprintf(gettext("Return to <a href=\"editcomponents.php?pid=%s\">components</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// default action
if (!isset($pid))
{
    header("Location: editproducts.php");
    exit;
}
d_DrawHeader(gettext("Select Component"));
if (isset($msg))
{
    switch ($msg)
    {
        case "1":
            print("<span class=\"text\"><center>" . gettext("Component added successfully") . "</center></span>");
            break;
        case "2":
            print("<p>" . gettext("A component by this name already exists; press the back button in your browser to choose a new name.") . "</p>");
            break;
        case "3":
            print("<p>" . gettext("ERROR: You submitted an empty field; press the back button in your browser to correct the problem.") . "</p>");
            break;
        case "4":
            print("<span class=\"text\"><center>" . gettext("Component removed.") . "</center></span>");
            break;
    }
}

$p_string['component'] = gettext("Component");
$p_string['desc']      = gettext("Description");
$p_string['inown']     = gettext("Initial Owner");
$p_string['action']    = gettext("Action");
$data = <<<EOT
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr bgcolor="{$config['barcol1']}">
            <td width="20%">{$p_string['component']}</td>
            <td width="50%">{$p_string['desc']}</td>
            <td width="20%">{$p_string['inown']}</td>
            <td width="10%">{$p_string['action']}</td>
        </tr>
EOT;

$result = $db->query("SELECT * FROM components WHERE (product = '$pid') AND (deleted = '0') ORDER BY name ASC");
dberror($result);
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $cid     = $row['cid'];
    $p_email = stripslashes($db->getOne("SELECT email FROM users WHERE uid = '" . $row['owner'] . "'"));
    $p_desc  = stripslashes($row['description']);
    $p_edit  = sprintf("<a href=\"editcomponents.php?cid=%s&pid=%s&action=edit\">%s</a>",$cid,$pid,stripslashes($row['name']));
    $p_del   = sprintf("<a href=\"editcomponents.php?cid=%s&pid=%s&action=del\">" . gettext("Delete") . "</a>",$cid,$pid);
    $data   .= <<<EOT
        <tr>
            <td width="20%">{$p_edit}</td>
            <td width="50%">{$p_desc}</td>
            <td width="20%">{$p_email}</td>
            <td width="10%">{$p_del}</td>
        </tr>
EOT;
}
print($data);

$p_string['addcomp'] = gettext("Add a new component");
$p_addlink           = sprintf("<a href=\"editcomponents.php?pid=%s&action=add\">" . gettext("Add") . "</a>", $pid);
$data = <<<EOT
        <tr>
            <td width="20%">{$p_string['addcomp']}</td>
            <td width="10%">{$p_addlink}</td>
        </tr>
    </table>
EOT;

print($data);

print("<p>" . sprintf(gettext("Return to <a href=\"editproducts.php?pid=%s&action=edit\">products</a>"), $pid) . "<br />");
print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
d_DrawFooter();
?>
