<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: editproducts.php,v 1.32 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['action']))      { $action      = $_REQUEST['action']; }      else { $action      = NULL; }
if (isset($_REQUEST['name']))        { $name        = $_REQUEST['name']; }        else { $name        = NULL; }
if (isset($_REQUEST['description'])) { $description = $_REQUEST['description']; } else { $description = NULL; }
if (isset($_REQUEST['pid']))         { $pid         = $_REQUEST['pid']; }         else { $pid         = NULL; }
if (isset($_REQUEST['msg']))         { $msg         = $_REQUEST['msg']; }         else { $msg         = NULL; }

d_StartPage(gettext("Select Product"));

if (!do_checkacs($_USER['access'])) exit;

d_DrawNav($_USER['uname']);

// form to add new product
if ($action == "add")
{
    d_DrawHeader(gettext("Add Product"));
    if (isset($msg))
    {
        switch ($msg)
        {
            case "1":
                print("<span class=\"text\"><center>" . gettext("Product added successfully") . "</center></span>");
                break;
            case "2":
                print("<p>" . gettext("A product by this name already exists.") . "</p>");
                break;
            case "3":
                print("<p>" . gettext("ERROR: You submitted an empty field.") . "</p>");
                break;
        }
    }
    d_DrawEditProd("insert",0,$name,$description);
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") ."<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// insert new product
if ($action == "insert")
{
    d_DrawHeader(gettext("Add Product"));
    // make sure product doesn't already exist
    $result = $db->query("SELECT pid FROM products WHERE (name = '$name') AND (deleted = '0')");
    dberror($result);
    if ($result->numRows() > 0)
    {
        $retq = "name=$name&description=$description&msg=2";
    } else {
        if ($name == "")
        {
            $retq = "name=$name&description=$description&msg=3";
        } else {
            $id      = $db->nextID('products');
            $query   = "INSERT INTO products (pid, name, description) VALUES ";
            $query  .= "('$id', '" . addslashes($name) . "', '";
            $query  .= addslashes(htmlspecialchars($description)) . "')";
            $result2 = $db->query($query);
            dberror($result2);
            $retq    = "msg=1";
            
        }
    }
    $result->free();
    header("Location: $PHP_SELF?action=add&$retq");
    exit;
}

// form to delete product
if ($action == "del")
{
    d_DrawHeader(gettext("Delete Product"));
    $pname              = $db->getOne("SELECT name FROM products WHERE pid = '$pid'");
    $p_delprod          = sprintf(gettext("Are you sure you want to delete the product <b>%s</b>?"), stripslashes($pname));
    $p_string['delete'] = gettext("Delete");
    $data               = <<<EOT
        <form method="post" action="editproducts.php">
        <p>{$p_delprod}</p>
        <input type="submit" value="{$p_string['delete']}">
        <input type="hidden" name="pid" value="{$pid}">
        <input type="hidden" name="action" value="delete">
        </form>
EOT;

    print($data);
    d_DrawFooter();
    exit;
}

// perform "delete"
if ($action == "delete")
{
    d_DrawHeader(gettext("Delete Product"));
    $result = $db->query("UPDATE products SET deleted = '1' WHERE pid = '$pid'");
    dberror($result);
    header("Location: $PHP_SELF?msg=4");
    exit;
}

// form to edit product
if ($action == "edit")
{
    d_DrawHeader(gettext("Change Product"));
    d_DrawEditProd("change",$pid);
    $p_editcomp = sprintf("<a href=\"editcomponents.php?pid=%s\">" . gettext("Edit components") . ":</a>", $pid);
    $p_editver  = sprintf("<a href=\"editversions.php?pid=%s\">" . gettext("Edit versions") . ":</a>", $pid);
    $data       = <<<EOT
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
            <tr>
                <td width="50%" align="right" valign="top">{$p_editcomp}</td>
                <td width="50%">
EOT;

    $result = $db->query("SELECT name,description FROM components WHERE (product = '$pid') AND (deleted = '0') ORDER BY name ASC");
    dberror($result);
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        $data .= sprintf("<b>%s</b>: %s<br />",stripslashes($row['name']),stripslashes($row['description']));
    }
    $result->free();

    $data .= <<<EOT
                </td>
            </tr>
            <tr>
                <td width="50%" align="right" valign="top">{$p_editver}</td>
                <td width="50%">
EOT;

    $result = $db->query("SELECT name FROM versions WHERE (product = '$pid') AND (deleted = '0') ORDER BY name ASC");
    dberror($result);
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        $data .= sprintf("<b>%s</b><br />",$row['name']);
    }
    $result->free();

    $data .= <<<EOT
                </td>
            </tr>
        </table>
EOT;

    print($data);
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// change product
if ($action == "change")
{
    d_DrawHeader(gettext("Change Product"));
    $query  = "UPDATE products SET name = '" . addslashes(htmlspecialchars($name)) . "' ";
    $query .= "WHERE pid = '$pid'";
    $result = $db->query($query);
    dberror($result);
    $query  = "UPDATE products SET description = '" . addslashes(htmlspecialchars($description)) . "' ";
    $query .= "WHERE pid = '$pid'";
    $result = $db->query($query);
    dberror($result);
    print("<span class=\"text\"><center>" . gettext("Product changed.") . "</center></span>");
    print("<p>" . gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "<br />");
    print(gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// default action
d_DrawHeader(gettext("Select Product"));

if (isset($msg))
{
    switch ($msg)
    {
        case "4":
            print("<span class=\"text\"><center>" . gettext("Product removed.") . "</center></span>");
            break;
    }
}

$p_string['product'] = gettext("Product");
$p_string['desc']    = gettext("Description");
$p_string['bugs']    = gettext("Bugs");
$p_string['action']  = gettext("Action");
$data                = <<<EOT
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr bgcolor="{$config['barcol1']}">
            <td width="20%">{$p_string['product']}</td>
            <td width="60%">{$p_string['desc']}</td>
            <td width="10%">{$p_string['bugs']}</td>
            <td width="10%">{$p_string['action']}</td>
        </tr>
EOT;

$result = $db->query("SELECT * FROM products WHERE deleted = '0' ORDER BY name ASC");
dberror($result);
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $p_editlink = sprintf("<a href=\"editproducts.php?pid=%s&action=edit\">%s</a>",$row['pid'],stripslashes($row['name']));
    $p_desc     = stripslashes($row['description']);
    $p_dellink  = sprintf("<a href=\"editproducts.php?pid=%s&action=del\">" . gettext("Delete") . "</a>", $row['pid']);
    $result2    = $db->query("SELECT bid FROM bugs WHERE product='" . $row['pid'] . "'");
    dberror($result2);
    $p_bugs     = $result2->numRows();
    $result2->free();

    $data      .= <<<EOT
        <tr>
            <td width="20%">{$p_editlink}</td>
            <td width="60%">{$p_desc}</td>
            <td width="10%">{$p_bugs}</td>
            <td width="10%">{$p_dellink}</td>
        </tr>
EOT;

}
$result->free();

$string['addprod'] = gettext("Add a new product");
$p_addprod         = "<a href=\"editproducts.php?action=add\">" . gettext("Add") . "</a>";
$data .= <<<EOT
        <tr>
            <td colspan="3" width="90%">{$string['addprod']}</td>
            <td width="10%">{$p_addprod}</td>
        </tr>
    </table>
EOT;

print($data);
print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");

d_DrawFooter();
?>
