<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: editusers.php,v 1.28 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['action']))    { $action    = $_REQUEST['action']; }    else { $action    = NULL; }
if (isset($_REQUEST['moduserid'])) { $moduserid = $_REQUEST['moduserid']; } else { $moduserid = NULL; }
if (isset($_REQUEST['name']))      { $name      = $_REQUEST['name']; }      else { $name      = NULL; }
if (isset($_REQUEST['uname']))     { $uname     = $_REQUEST['uname']; }     else { $uname     = NULL; }
if (isset($_REQUEST['email']))     { $email     = $_REQUEST['email']; }     else { $email     = NULL; }
if (isset($_REQUEST['access']))    { $access    = $_REQUEST['access']; }    else { $access    = NULL; }
if (isset($_REQUEST['pass1']))     { $pass1     = $_REQUEST['pass1']; }     else { $pass1     = NULL; }
if (isset($_REQUEST['pass2']))     { $pass2     = $_REQUEST['pass2']; }     else { $pass2     = NULL; }
if (isset($_REQUEST['owner']))     { $owner     = $_REQUEST['owner']; }     else { $owner     = NULL; }
if (isset($_REQUEST['bugowner']))  { $bugowner  = $_REQUEST['bugowner']; }  else { $bugowner  = NULL; }

d_StartPage(gettext("Select User"));

if (!do_checkacs($_USER['access'])) exit;

d_DrawNav($_USER['uname']);

// form to delete user
if ($action == "del")
{
    d_DrawHeader(gettext("Delete User"));
    $result = $db->query("SELECT uid,name FROM users WHERE uid = '$moduserid'");
    dberror($result);
    $row    = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $result->free();
    if ($row['uid'] == 1)
    {
        print("<p>" . gettext("You cannot delete the administrator account.") . "</p>");
        d_DrawFooter();
        exit;
    }
    print("<form method=\"post\" action=\"editusers.php\">");
    print("<p>" . sprintf(gettext("Are you sure you want to delete the user <b>%s</b>?"), stripslashes($row['name'])) . "</p>");
    // check if this user owns any components
    $result = $db->query("SELECT name FROM components WHERE (owner = '$moduserid') AND (deleted = '0')");
    dberror($result);
    if ($result->numRows() > 0)
    {
        print("<p>" . gettext("This user owns the following components:") . "</p>");
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            print("<b>" . $row['name'] . "</b><br />");
        }
        $result->free();
        print("<p>" . gettext("If you want to delete this user, you should reassign their components to someone else.") . "</p>");
        print("<p>" . gettext("Select a new component owner:") . "</p>");
        print("<select name=\"owner\" value=\"1\">");
        $result = $db->query("SELECT uid,email FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0')");
        dberror($result);
        while ($user = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            print(sprintf("<option value=\"%s\">%s</option>\n",$user['uid'],$user['email']));
        }
        print("</select>");
    }
    // check if this user owns any bugs
    $result = $db->query("SELECT * FROM bugs WHERE assigned = '$moduserid'");
    dberror($result);
    if ($result->numRows() > 0)
    {
        print("<p>" . gettext("This user owns the following bugs:") . "</p>");
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            $status = $db->getOne("SELECT name FROM status_d WHERE id = '" . $row['status'] . "'");
            print(sprintf("<b>%s</b>: %s (%s)<br />",$row['bid'], $row['shortdesc'], $status));
        }
        $result->free();
        print("<p>" . gettext("If you want to delete this user, you should reassign their bugs to someone else.") . "</p>");
        print("<p>" . gettext("Select a new component owner:") . "</p>");
        print("<select name=\"bugowner\" value=\"1\">");
        $result = $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0')");
        dberror($result);
        while ($user = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
            print(sprintf("<option value=\"%s\">%s</option>\n",$user['uid'],$user['email']));
        }
        $result->free();
        print("</select>");
    }
    print("<br /><br /><input type=\"submit\" value=\"" . gettext("Delete User") . "\">");
    print("<input type=\"hidden\" name=\"moduserid\" value=\"$moduserid\">");
    print("<input type=\"hidden\" name=\"action\" value=\"delete\">");
    print("</form>");
    d_DrawFooter();
    exit;
}

// perform delete (we don't actually really delete the user)
if ($action == "delete")
{
    d_DrawHeader(gettext("Delete User"));
    $result = $db->query("UPDATE users SET deleted = '1' WHERE uid = '$moduserid'");
    dberror($result);
    print("<span class=\"text\"><center>" . gettext("User removed.") . "</center></span>");
    if (isset($owner))
    {
        $result = $db->query("UPDATE components SET owner = '$owner' WHERE (owner = '$moduserid') AND (deleted = '0')");
        dberror($result);
        print("<p>" . gettext("Components re-assigned.") . "</p>");
    }
    if (isset($bugowner))
    {
        $result = $db->query("UPDATE bugs SET assigned = '$bugowner' WHERE assigned = '$moduserid'");
        dberror($result);
        print("<p>" . gettext("Bugs re-assigned.") . "</p>");
    }
    print("<p>" . gettext("Return to <a href=\"editusers.php\">user list</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// form to edit user
if ($action == "edit")
{
    d_DrawHeader(gettext("Edit User"));
    d_DrawEditUser($moduserid);
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// change user
if ($action == "change")
{
    d_DrawHeader(gettext("Edit User"));
    $query  = "UPDATE users SET name = '" . addslashes(htmlspecialchars($name)) . "' ";
    $query .= "WHERE uid = '$moduserid'";
    $result = $db->query($query);
    dberror($result);
    $query  = "UPDATE users SET uname = '" . addslashes(htmlspecialchars($uname)) . "' ";
    $query .= "WHERE uid = '$moduserid'";
    $result = $db->query($query);
    dberror($result);
    $query  = "UPDATE users SET email = '" . addslashes(htmlspecialchars($email)) . "' ";
    $query .= "WHERE uid = '$moduserid'";
    $result = $db->query($query);
    dberror($result);
    $result = $db->query("UPDATE users SET access = '$access' WHERE uid = '$moduserid'");
    dberror($result);

    if ($pass1 != "")
    {
        if ($pass1 == $pass2)
        {
            $cpass  = md5($pass1);
            $query  = "UPDATE users SET passwd = '" . $cpass . "' ";
            $query .= "WHERE uid = '$moduserid'";
            $result = $db->query($query);
            dberror($result);
        } else {
            print("<span class=\"text\"><font color=\"red\"><center>" . gettext("Passwords do not match; no change to user's password.") . "</center></font></span>");
        }
    }

    print("<span class=\"text\"><center>" . gettext("User information changed.") . "</center></span>");
    print("<p>" . gettext("Return to <a href=\"editusers.php\">user list</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// default action
d_DrawHeader(gettext("Select User"));

$p_string['userid']   = gettext("User ID");
$p_string['realname'] = gettext("Real Name");
$p_string['username'] = gettext("User Name");
$p_string['emailadd'] = gettext("Email Address");
$p_string['lastlog']  = gettext("Last Login");
$p_string['acslvl']   = gettext("Access Level");
$p_string['action']   = gettext("Action");

$data = <<<EOT
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr bgcolor="{$config['barcol1']}">
            <td width="5%">{$p_string['userid']}</td>
            <td width="15%">{$p_string['realname']}</td>
            <td width="10%">{$p_string['username']}</td>
            <td width="30%">{$p_string['emailadd']}</td>
            <td width="20%">{$p_string['lastlog']}</td>
            <td width="10%">{$p_string['acslvl']}</td>
            <td width="10%" align="right">{$p_string['action']}</td>
        </tr>
EOT;

$result = $db->query("SELECT uid,name,uname,email,laston,access FROM users WHERE deleted = '0' ORDER BY uid ASC");
dberror($result);
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $p_editlink = sprintf("<a href=\"editusers.php?moduserid=%s&action=edit\">%s</a>",$row['uid'],stripslashes($row['name']));
    $p_dellink  = sprintf("<a href=\"editusers.php?moduserid=%s&action=del\">" . gettext("Delete") . "</a>",$row['uid']);
    $p_laston   = d_getTime($row['laston']);
    $data      .= <<<EOT
        <tr>
            <td width="5%">{$row['uid']}</td>
            <td width="15%">{$p_editlink}</td>
            <td width="10%">{$row['uname']}</td>
            <td width="30%">{$row['email']}</td>
            <td width="20%">{$p_laston}</td>
            <td width="10%">{$row['access']}</td>
            <td width="10%" align="right">{$p_dellink}</td>
        </tr>
EOT;
}

$p_string['addnew'] = gettext("Add a new user");
$p_string['add']    = gettext("Add");
$data .= <<<EOT
        <tr>
            <td width="20%" colspan="2">{$p_string['addnew']}</td>
            <td width="10%"><a href="newuser.php?admin=1">{$p_string['add']}</a></td>
        </tr>
    </table>
EOT;

print($data);
print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
d_DrawFooter();
?>
