<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: editversions.php,v 1.26 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['action'])) { $action = $_REQUEST['action']; } else { $action = NULL; }
if (isset($_REQUEST['pid']))    { $pid    = $_REQUEST['pid']; }    else { $pid    = NULL; }
if (isset($_REQUEST['name']))   { $name   = $_REQUEST['name']; }   else { $name   = NULL; }
if (isset($_REQUEST['vid']))    { $vid    = $_REQUEST['vid']; }    else { $vid    = NULL; }

d_StartPage(gettext("Select Version"));

if (!do_checkacs($_USER['access'])) exit;

d_DrawNav($_USER['uname']);

// form to add new version
if ($action == "add")
{
    d_DrawHeader(gettext("Add Version"));
    if (isset($msg))
    {
        switch ($msg)
        {
            case "1":
                print("<span class=\"text\"><center>" . gettext("Version added successfully") . "</center></span>");
                break;
            case "2":
                print("<p>" . gettext("A version by this name already exists.") . "</p>");
                break;
            case "3":
                print("<p>" . gettext("ERROR: You submitted an empty field.") . "</p>");
                break;
        }
    }
    d_DrawEditVer("insert",0,$pid,$name);
    print("<p>" . sprintf(gettext("Return to <a href=\"editversions.php?pid=%s\">versions</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// insert new version
if ($action == "insert")
{
    d_DrawHeader(gettext("Add Version"));
    // check if version already exists
    $result = $db->query("SELECT vid FROM versions WHERE (name = '$name') AND (deleted = '0') AND (product = '$pid')");
    dberror($result);
    if ($result->numRows() > 0)
    {
        $retq = "name=$name&msg=2";
    } else {
        if ($name == "")
        {
            $retq = "name=$name&msg=3";
        } else {
            $id      = $db->nextID('versions');
            $query   = "INSERT INTO versions (vid, product, name) VALUES ";
            $query  .= "('$id', '" . $pid . "', '";
            $query  .= addslashes(htmlspecialchars($name)) . "')";
            $result2 = $db->query($query);
            dberror($result2);
            $retq    = "msg=1";
        }
    }
    $result->free();
    header("Location: $PHP_SELF?pid=$pid&action=add&$retq");
    exit;
}

// form to delete version
if ($action == "del")
{
    d_DrawHeader(gettext("Delete Version"));
    $vname              = $db->getOne("SELECT name FROM versions WHERE vid = '$vid'");
    $p_string['sdel']   = sprintf(gettext("Are you sure you want to delete the version <b>%s</b>?"), stripslashes($vname));
    $p_string['delete'] = gettext("Delete");

    $data = <<<EOT
        <form method="post" action="editversions.php">
        <p>{$p_string['sdel']}</p>
        <input type="submit" value="{$p_string['delete']}">
        <input type="hidden" name="vid" value="{$vid}">
        <input type="hidden" name="pid" value="{$pid}">
        <input type="hidden" name="action" value="delete">
        </form>
EOT;

    print($data);
    d_DrawFooter();
    exit;
}

// perform delete
if ($action == "delete")
{
    d_DrawHeader(gettext("Delete Version"));
    $result = $db->query("UPDATE versions SET deleted = '1' WHERE vid = '$vid'");
    dberror($result);
    print("<span class=\"text\"><center>" . gettext("Version removed.") . "</center></span>");
    print("<p>" . sprintf(gettext("Return to <a href=\"editversions.php?pid=%s\">versions</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// form to edit version
if ($action == "edit")
{
    d_DrawHeader(gettext("Change Version"));
    d_DrawEditVer("change",$vid,$pid);
    print("<p>" . sprintf(gettext("Return to <a href=\"editversions.php?pid=%s\">versions</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// change version
if ($action == "change")
{
    d_DrawHeader(gettext("Change Version"));
    $query  = "UPDATE versions SET name = '" . addslashes(htmlspecialchars($name)) . "' ";
    $query .= "WHERE vid = '$vid'";
    $result = $db->query($query);
    dberror($result);
    print("<span class=\"text\"><center>" . gettext("Version changed.") . "</center></span>");
    print("<p>" . sprintf(gettext("Return to <a href=\"editversions.php?pid=%s\">versions</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
}

// default action
if (!isset($pid))
{
    header("Location: editproducts.php");
    exit;
}
d_DrawHeader(gettext("Select Version"));
$p_string['version'] = gettext("Version");
$p_string['action']  = gettext("Action");

$data = <<<EOT
    <table border="0" cellpadding="0" cellspacing="0" width="30%">
        <tr bgcolor="{$config['barcol1']}">
            <td width="20%">{$p_string['version']}</td>
            <td width="10%">{$p_string['action']}</td>
        </tr>
EOT;

$result = $db->query("SELECT * FROM versions WHERE (product = '$pid') AND (deleted = '0') ORDER BY name ASC");
dberror($result);
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $vid = $row['vid'];
    $p_editlink = sprintf("<a href=\"editversions.php?vid=%s&pid=%s&action=edit\">%s</a>",$vid,$pid,stripslashes($row['name']));
    $p_dellink  = sprintf("<a href=\"editversions.php?vid=%s&pid=%s&action=del\">" . gettext("Delete") . "</a>",$vid,$pid);
    $data .= <<<EOT
        <tr>
            <td width="20%">{$p_editlink}</td>
            <td width="10%">{$p_dellink}</td>
        </tr>
EOT;
}
$result->free();

$p_string['addver'] = gettext("Add a new version");
$paddlink           = sprintf("<a href=\"editversions.php?pid=%s&action=add\">" . gettext("Add") . "</a>", $pid);
$data .= <<<EOT
        <tr>
            <td width="20%">{$p_string['addver']}</td>
            <td width="10%">{$paddlink}</td>
        </tr>
    </table>
EOT;

print($data);
print("<p>" . sprintf(gettext("Return to <a href=\"editproducts.php?pid=%s&action=edit\">products</a>"), $pid) . "<br />");
print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
d_DrawFooter();
?>
