<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: reports.php,v 1.27 2004/02/04 16:54:53 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['pid'])) { $pid = $_REQUEST['pid']; } else { $pid = NULL; }

d_StartPage(gettext("Bug Reports"));
if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) { exit; }
d_DrawNav($_USER['uname']);
  
$result = $db->query("SELECT pid FROM products");
dberror($result);
if ($result->numRows() == 1)
{
    $row = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $pid = $row['pid'];
}
$result->free();

if (!isset($pid))
{
    d_DrawHeader(gettext("Select Product To Report On"));
    $p_string['selprod'] = gettext("Select Product");
    $p_string['cont']    = gettext("Continue");
    $p_string['allprod'] = gettext("All Products");

    // create product select list
    $result = $db->query("SELECT pid,name FROM products WHERE deleted = '0' ORDER BY name");
    dberror($result);
    $prod_sellist = NULL;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        $prod_sellist .= sprintf("<option value=\"%s\">%s</option>\n",$row['pid'],$row['name']);
    }
    $result->free();

    $data = <<<EOT
        <form method="post" action="reports.php">
        <table border="0" cellpadding="0" cellspacing="0" width="40%" align="center">
            <tr>
                <td width="50%" align="right">{$p_string['selprod']}:</td>
                <td width="50%">
                    <select name="pid">
                    {$prod_sellist}
                    <option value="all" SELECTED>{$p_string['allprod']}</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td width="50%">&nbsp;</td>
                <td width="50%"><input type="submit" value="{$p_string['cont']}"></td>
            </tr>
        </table>
        </form>
EOT;

    print($data);
    d_DrawFooter();
    exit;
}

d_DrawHeader(gettext("Bug Reports"));

$date = date(sprintf("%s %s", $_CONF['datefmt'], $_CONF['timefmt']));
if ($pid != "all")
{
    $result = $db->query("SELECT * FROM products WHERE pid = '$pid'");
    dberror($result);
    $prod   = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $result->free();
    $qtag   = " AND product = '$pid'";
    $qtag2  = " WHERE product = '$pid'";
    $qtag3  = " AND (bugs.product = '$pid')";
} else {
    $prod['name'] = gettext("All Products");
    $qtag  = "";
    $qtag2 = "";
    $qtag3 = "";
}

print("<p><b>" . sprintf(gettext("Bug Report for %s"), $prod['name']) . "</b></p>");
print("<p>$date</p>");
print("<p><b>" . gettext("Summary") . "</b></p>");

$p_string['newweek']  = gettext("New Bugs This Week");
$p_string['resweek']  = gettext("Resolved Bugs This Week");
$p_string['newmonth'] = gettext("New Bugs In Last 30 Days");
$p_string['resmonth'] = gettext("Resolved Bugs In Last 30 Days");
$p_string['bugsnew']  = gettext("Bugs Marked New");
$p_string['bugsass']  = gettext("Bugs Marked Assigned");
$p_string['bugsver']  = gettext("Bugs Marked Verified");
$p_string['bugsunc']  = gettext("Bugs Marked Unconfirmed");
$p_string['bugsinfo'] = gettext("Bugs Requiring More Info");
$p_string['bugsreop'] = gettext("Bugs Marked Reopened");
$p_string['bugstot']  = gettext("Total Bugs");
$p_string['opbyown']  = gettext("Open Bug Count by Owner");
$p_string['owner']    = gettext("Owner");
$p_string['new']      = gettext("New");
$p_string['assigned'] = gettext("Assigned");
$p_string['verified'] = gettext("Verified");
$p_string['unconf']   = gettext("Unconfirmed");
$p_string['reop']     = gettext("Reopened");
$p_string['toval']    = gettext("To Validate");
$p_string['needwork'] = gettext("Needs Work");
$p_string['needinfo'] = gettext("Needs Info");
$p_string['total']    = gettext("Total");
$p_string['bugbyrep'] = gettext("Bug Count by Reporter");
$p_string['reported'] = gettext("Reported");
$p_string['lastrep']  = gettext("Last Reported");
$p_string['sumpcom']  = gettext("Summary of Participant Comments");
$p_string['partic']   = gettext("Participant");
$p_string['lastmon']  = gettext("In Last 30");
$p_string['lastcom']  = gettext("Last Comment");
$p_string['openownr'] = gettext("Individual Open Bugs by Owner");
$p_string['closownr'] = gettext("Closed Bug Count by Owner");
$p_string['closed']   = gettext("Closed");
$p_string['resolved'] = gettext("Resolved");

// new bugs this week
$sunday = date("YmdHis",mktime(0,0,0,date("m"),date("d")-date("w",mktime(0,0,0,date("m"),date("d"),date("Y"))),date("Y")));
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE creation >= '$sunday' %s", $qtag));
dberror($result);
$p_newweek = $result->numRows();
$result->free();

// resolved bugs this week
$sunday = date("YmdHis",mktime(0,0,0,date("m"),date("d")-date("w",mktime(0,0,0,date("m"),date("d"),date("Y"))),date("Y")));
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE (modified >= '$sunday') AND (status = '4') %s", $qtag));
dberror($result);
$p_resweek = $result->numRows();
$result->free();

// new bugs in last 30 days
$thirty = date("YmdHis", mktime(0,0,0,date("m")-1,date("d"),date("Y")));
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE creation >= '$thirty' %s", $qtag));
dberror($result);
$p_newmonth = $result->numRows();
$result->free();

// resolved bugs in last 30 days
$thirty = date("YmdHis", mktime(0,0,0,date("m")-1,date("d"),date("Y")));
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE (modified >= '$thirty') AND (status = '4') %s", $qtag));
dberror($result);
$p_resmonth = $result->numRows();
$result->free();

// bugs marked new
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE status = '1' %s", $qtag));
dberror($result);
$p_bugsnew = $result->numRows();
$result->free();

// bugs marked assigned
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE status = '2' %s", $qtag));
dberror($result);
$p_bugsass = $result->numRows();
$result->free();

// bugs marked verified
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE status = '5' %s", $qtag));
dberror($result);
$p_bugsver = $result->numRows();
$result->free();

// bugs marked unconfirmed
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE status = '0' %s", $qtag));
dberror($result);
$p_bugsunc = $result->numRows();
$result->free();

// bugs requiring more info
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE status = '9' %s", $qtag));
dberror($result);
$p_bugsinfo = $result->numRows();
$result->free();

// bugs marked reopened
$result = $db->query(sprintf("SELECT bid FROM bugs WHERE status = '3' %s", $qtag));
dberror($result);
$p_bugsreop = $result->numRows();
$result->free();

// total bugs
$result = $db->query(sprintf("SELECT bid FROM bugs %s", $qtag2));
dberror($result);
$p_bugstot = $result->numRows();
$result->free();

// build "open bug count by owner" table rows
$openbugcount = d_repassignrow(0, "Unassigned", $qtag);
$result = $db->query("SELECT uid,name FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY name");
dberror($result);
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $openbugcount .= d_repassignrow($row['uid'], $row['name'], $qtag);
}
$result->free();

// build "bug count by reporter" table rows
$lastreported = d_replastreprow(0, "Unassigned", $qtag);
$result = $db->query("SELECT uid,name FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY name");
dberror($result);
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $lastreported .= d_replastreprow($row['uid'], $row['name'], $qtag);
}
$result->free();

// build "summary of participant comments" table rows
$summaryofcomments  = NULL;
$summaryofcomments .= d_repsummcomm($qtag3);

// build "individual open bugs by owner" table rows
$openbyowner = d_repopenbugs(0, "Unassigned", $qtag);
$result = $db->query("SELECT uid,name FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY name");
dberror($result);
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $openbyowner .= d_repopenbugs($row['uid'], $row['name'], $qtag);
}
$result->free();

// build "closed bug count by owner"
$closedbyowner = d_repclosedbugs(0, "Unassigned", $qtag);
$result = $db->query("SELECT uid,name FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY name");
dberror($result);
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $closedbyowner .= d_repclosedbugs($row['uid'], $row['name'], $qtag);
}
$result->free();

$data = <<<EOT
    <table border="0" cellpadding="0" cellspacing="0" width="30%">
        <tr>
            <td width="55%">{$p_string['newweek']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_newweek}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['resweek']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_resweek}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['newmonth']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_newmonth}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['resmonth']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_resmonth}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['bugsnew']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_bugsnew}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['bugsass']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_bugsass}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['bugsver']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_bugsver}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['bugsunc']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_bugsunc}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['bugsinfo']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_bugsinfo}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['bugsreop']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_bugsreop}</td>
        </tr>
        <tr>
            <td width="55%">{$p_string['bugstot']}:</td>
            <td width="10%">&nbsp;</td>
            <td width="35%">{$p_bugstot}</td>
        </tr>
    </table>
    <br /><p><b>{$p_string['opbyown']}</b></p>
    <table border="0" cellpadding="0" cellspacing="0" width="80%">
        <tr>
            <td width="20%"><u>{$p_string['owner']}</u></td>
            <td width="5%" align="center"><u>{$p_string['new']}</u></td>
            <td width="10%" align="center"><u>{$p_string['assigned']}</u></td>
            <td width="10%" align="center"><u>{$p_string['verified']}</u></td>
            <td width="10%" align="center"><u>{$p_string['unconf']}</u></td>
            <td width="10%" align="center"><u>{$p_string['reop']}</u></td>
            <td width="10%" align="center"><u>{$p_string['toval']}</u></td>
            <td width="10%" align="center"><u>{$p_string['needwork']}</u></td>
            <td width="10%" align="center"><u>{$p_string['needinfo']}</u></td>
            <td width="5%" align="center"><u>{$p_string['total']}</u></td>
        </tr>
        {$openbugcount}
        <tr>
            <td colspan="7"><br /><p><b>{$p_string['bugbyrep']}</b><br />&nbsp;</p></td>
        </tr>
        <tr>
            <td width="20%"><u>{$p_string['owner']}</u></td>
            <td width="10%" align="center"><u>{$p_string['reported']}</u></td>
            <td width="30%" colspan="3" align="center"><u>{$p_string['lastrep']}</u></td>
            <td colspan="2">&nbsp;</td>
        </tr>
        {$lastreported}
        <tr>
            <td colspan="7"><br /><p><b>{$p_string['sumpcom']}</b><br />&nbsp;</p></td>
        </tr>
        <tr>
            <td width="20%"><u>{$p_string['partic']}</u></td>
            <td width="10%" align="center"><u>{$p_string['lastmon']}</u></td>
            <td width="10%" align="center"><u>{$p_string['total']}</u></td>
            <td width="30%" colspan="3" align="center"><u>{$p_string['lastcom']}</u></td>
            <td>&nbsp;</td>
        </tr>
        ${summaryofcomments}
    </table>
    <p><b>{$p_string['openownr']}</b></p>
    <table border="1" cellpadding="0" cellspacing="0" width="80%">
        <tr>
            <td width="20%">{$p_string['owner']}</td>
            <td width="15%" align="center">{$p_string['new']}</td>
            <td width="15%" align="center">{$p_string['assigned']}</td>
            <td width="15%" align="center">{$p_string['verified']}</td>
            <td width="10%" align="center">{$p_string['unconf']}</td>
            <td width="10%" align="center">{$p_string['reop']}</td>
            <td width="15%" align="center">{$p_string['needinfo']}</td>
        </tr>
        {$openbyowner}
    </table>
    <br /><p><b>{$p_string['closownr']}</b></p>
    <table border="0" cellpadding="0" cellspacing="0" width="50%">
        <tr>
            <td width="30%"><u>{$p_string['owner']}</u></td>
            <td width="10%" align="center"><u>{$p_string['resolved']}</u></td>
            <td width="10%" align="center"><u>{$p_string['closed']}</u></td>
            <td width="10%" align="center"><u>{$p_string['total']}</u></td>
        </tr>
        {$closedbyowner}
    </table>
EOT;

print($data);
d_DrawFooter();

?>
